package me.wazup.hideandseek.custommaps;

import java.util.Iterator;
import org.bukkit.map.MapFont;
import org.bukkit.map.MinecraftFont;
import org.bukkit.entity.Player;
import org.bukkit.map.MapCanvas;
import org.bukkit.map.MapView;
import me.wazup.hideandseek.utils.Utils;
import javax.imageio.ImageIO;
import java.net.URL;
import org.bukkit.plugin.Plugin;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.plugin.java.JavaPlugin;
import java.awt.Image;
import java.util.List;
import org.bukkit.map.MapRenderer;

public class CombinedMapRenderer extends MapRenderer
{
    List<String> texts;
    Image image;
    boolean rendered;
    
    public CombinedMapRenderer(final JavaPlugin javaPlugin, final List<String> texts, final String s, final boolean b) {
        this.rendered = false;
        this.texts = texts;
        if (s == null || s.isEmpty()) {
            return;
        }
        if (b) {
            new BukkitRunnable() {
                public void run() {
                    CombinedMapRenderer.this.loadImage(s);
                }
            }.runTaskAsynchronously((Plugin)javaPlugin);
        }
        else {
            this.loadImage(s);
        }
    }
    
    private void loadImage(final String s) {
        try {
            final int n = this.texts.isEmpty() ? 128 : 64;
            this.image = ImageIO.read(new URL(s)).getScaledInstance(n, n, 4);
        }
        catch (final Exception ex) {
            Utils.error("Could not load the image " + s + " in config.yml. Try a different image or a different hosting website.");
        }
    }
    
    public void render(final MapView mapView, final MapCanvas mapCanvas, final Player player) {
        if (!this.rendered) {
            this.rendered = true;
            int n = 1;
            final Iterator<String> iterator = this.texts.iterator();
            while (iterator.hasNext()) {
                mapCanvas.drawText(25, n++ * 10, (MapFont)MinecraftFont.Font, (String)iterator.next());
            }
            if (this.image != null) {
                if (!this.texts.isEmpty()) {
                    mapCanvas.drawImage(32, n * 10 + 10, this.image);
                }
                else {
                    mapCanvas.drawImage(0, 0, this.image);
                }
            }
        }
    }
}
